
struct VS_INPUT
{
    float3 Pos      : POSITION;
	float3 Normal   : NORMAL;
    float2 tc       : TEXCOORD0;
};

struct VS_OUTPUT
{
	float4  Pos			: SV_POSITION;
	float2  tc0			: TEXCOORD0;	
	float2  tc1			: TEXCOORD1;
};

struct PS_OUTPUT
{
    float4 Color : COLOR;
};

float       scale;

Texture2D   noise0;
Texture2D   noise1;

// samplers
SamplerState N0
{
	Filter = MIN_MAG_MIP_LINEAR;
	AddressU  = WRAP;		
	AddressV  = WRAP;
};

SamplerState N1
{
	Filter = MIN_MAG_MIP_LINEAR;
	AddressU  = WRAP;		
	AddressV  = WRAP;
};


VS_OUTPUT VS(VS_INPUT i)
{
	VS_OUTPUT o;
	o.Pos = float4( i.tc.x*2-1,1-i.tc.y*2, 0, 1 );
	o.tc0 = scale*i.Pos.xz*0.007813;
	o.tc1 = scale*i.Pos.xz*0.125;
	return o;
}


float4 PS(VS_OUTPUT i) : SV_Target
{
    float c = noise0.Sample(N0, i.tc0) + noise1.Sample(N1, i.tc1) - 0.5;
    return float4( c, c, c, 1 );
}

technique10 T0
{
	pass P0
	{
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
        SetGeometryShader( NULL );
        SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}

